diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/coyote-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/coyote-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/coyote-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/coyote-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -114,6 +114,9 @@ MACHINE_START(ADI_COYOTE, "ADI Engineeri
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= coyote_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/dsmg600-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/dsmg600-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/dsmg600-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/dsmg600-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -44,7 +44,7 @@ void __init dsmg600_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init dsmg600_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init dsmg600_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[MAX_DEV][IRQ_LINES] = {
 		{ IXP4XX_GPIO_IRQ(INTE), -1, -1 },
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/dsmg600-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/dsmg600-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/dsmg600-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/dsmg600-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -284,4 +284,7 @@ MACHINE_START(DSMG600, "D-Link DSM-G600
 	.init_irq	= ixp4xx_init_irq,
 	.timer          = &dsmg600_timer,
 	.init_machine	= dsmg600_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/fsg-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/fsg-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/fsg-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/fsg-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -38,7 +38,7 @@ void __init fsg_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init fsg_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init fsg_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[IRQ_LINES] = {
 		IXP4XX_GPIO_IRQ(INTC),
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/fsg-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/fsg-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/fsg-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/fsg-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -275,5 +275,8 @@ MACHINE_START(FSG, "Freecom FSG-3")
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= fsg_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/gateway7001-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gateway7001-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/gateway7001-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gateway7001-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -35,7 +35,8 @@ void __init gateway7001_pci_preinit(void
 	ixp4xx_pci_preinit();
 }
 
-static int __init gateway7001_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init gateway7001_map_irq(const struct pci_dev *dev, u8 slot,
+	u8 pin)
 {
 	if (slot == 1)
 		return IRQ_IXP4XX_GPIO11;
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/gateway7001-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gateway7001-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/gateway7001-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gateway7001-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -101,5 +101,8 @@ MACHINE_START(GATEWAY7001, "Gateway 7001
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= gateway7001_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/goramo_mlr.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/goramo_mlr.c
--- linux-3.0/arch/arm/mach-ixp4xx/goramo_mlr.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/goramo_mlr.c	2011-10-18 04:06:23.000000000 +0000
@@ -462,7 +462,7 @@ static void __init gmlr_pci_postinit(voi
 	}
 }
 
-static int __init gmlr_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init gmlr_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	switch(slot) {
 	case SLOT_ETHA:	return IXP4XX_GPIO_IRQ(GPIO_IRQ_ETHA);
@@ -501,4 +501,7 @@ MACHINE_START(GORAMO_MLR, "MultiLink")
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= gmlr_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/gtwx5715-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gtwx5715-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/gtwx5715-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gtwx5715-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -49,7 +49,7 @@ void __init gtwx5715_pci_preinit(void)
 }
 
 
-static int __init gtwx5715_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init gtwx5715_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	int rc = -1;
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/gtwx5715-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gtwx5715-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/gtwx5715-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/gtwx5715-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -169,6 +169,9 @@ MACHINE_START(GTWX5715, "Gemtek GTWX5715
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= gtwx5715_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-ixp4xx/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -17,19 +17,14 @@
 #ifndef __ASM_ARCH_HARDWARE_H__
 #define __ASM_ARCH_HARDWARE_H__
 
-#define PCIBIOS_MIN_IO		0x00001000
 #ifdef CONFIG_IXP4XX_INDIRECT_PCI
-#define PCIBIOS_MIN_MEM		0x10000000 /* 1 GB of indirect PCI MMIO space */
 #define PCIBIOS_MAX_MEM		0x4FFFFFFF
 #else
-#define PCIBIOS_MIN_MEM		0x48000000 /* 64 MB of PCI MMIO space */
 #define PCIBIOS_MAX_MEM		0x4BFFFFFF
 #endif
 
 #define ARCH_HAS_DMA_SET_COHERENT_MASK
 
-#define pcibios_assign_all_busses()	1
-
 /* Register locations and bits */
 #include "ixp4xx-regs.h"
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/include/mach/memory.h torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/include/mach/memory.h
--- linux-3.0/arch/arm/mach-ixp4xx/include/mach/memory.h	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/include/mach/memory.h	2011-10-18 04:06:23.000000000 +0000
@@ -14,8 +14,4 @@
  */
 #define PLAT_PHYS_OFFSET	UL(0x00000000)
 
-#ifdef CONFIG_PCI
-#define ARM_DMA_ZONE_SIZE	SZ_64M
-#endif
-
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/ixdp425-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/ixdp425-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/ixdp425-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/ixdp425-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -43,7 +43,7 @@ void __init ixdp425_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init ixdp425_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init ixdp425_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[IRQ_LINES] = {
 		IXP4XX_GPIO_IRQ(INTA),
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/ixdp425-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/ixdp425-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/ixdp425-setup.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/ixdp425-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -258,6 +258,9 @@ MACHINE_START(IXDP425, "Intel IXDP425 De
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= ixdp425_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
 
@@ -269,6 +272,9 @@ MACHINE_START(IXDP465, "Intel IXDP465 De
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= ixdp425_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
 
@@ -280,6 +286,9 @@ MACHINE_START(IXCDP1100, "Intel IXCDP110
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= ixdp425_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
 
@@ -291,5 +300,8 @@ MACHINE_START(KIXRP435, "Intel KIXRP435
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= ixdp425_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/ixdpg425-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/ixdpg425-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/ixdpg425-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/ixdpg425-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,7 +31,7 @@ void __init ixdpg425_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init ixdpg425_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init ixdpg425_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	if (slot == 12 || slot == 13)
 		return IRQ_IXP4XX_GPIO7;
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/nas100d-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nas100d-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/nas100d-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nas100d-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -41,7 +41,7 @@ void __init nas100d_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init nas100d_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init nas100d_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[MAX_DEV][IRQ_LINES] = {
 		{ IXP4XX_GPIO_IRQ(INTA), -1, -1 },
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/nas100d-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nas100d-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/nas100d-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nas100d-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -319,4 +319,7 @@ MACHINE_START(NAS100D, "Iomega NAS 100d"
 	.init_irq	= ixp4xx_init_irq,
 	.timer          = &ixp4xx_timer,
 	.init_machine	= nas100d_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/nslu2-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nslu2-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/nslu2-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nslu2-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -38,7 +38,7 @@ void __init nslu2_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init nslu2_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init nslu2_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	static int pci_irq_table[IRQ_LINES] = {
 		IXP4XX_GPIO_IRQ(INTA),
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/nslu2-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nslu2-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/nslu2-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/nslu2-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -305,4 +305,7 @@ MACHINE_START(NSLU2, "Linksys NSLU2")
 	.init_irq	= ixp4xx_init_irq,
 	.timer          = &nslu2_timer,
 	.init_machine	= nslu2_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/vulcan-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/vulcan-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/vulcan-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/vulcan-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -43,7 +43,7 @@ void __init vulcan_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init vulcan_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init vulcan_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	if (slot == 1)
 		return IXP4XX_GPIO_IRQ(INTA);
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/vulcan-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/vulcan-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/vulcan-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/vulcan-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -241,4 +241,7 @@ MACHINE_START(ARCOM_VULCAN, "Arcom/Eurot
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= vulcan_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/wg302v2-pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/wg302v2-pci.c
--- linux-3.0/arch/arm/mach-ixp4xx/wg302v2-pci.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/wg302v2-pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -35,7 +35,7 @@ void __init wg302v2_pci_preinit(void)
 	ixp4xx_pci_preinit();
 }
 
-static int __init wg302v2_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init wg302v2_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	if (slot == 1)
 		return IRQ_IXP4XX_GPIO8;
diff -NurpP --minimal linux-3.0/arch/arm/mach-ixp4xx/wg302v2-setup.c torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/wg302v2-setup.c
--- linux-3.0/arch/arm/mach-ixp4xx/wg302v2-setup.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ixp4xx/wg302v2-setup.c	2011-10-18 04:06:23.000000000 +0000
@@ -102,5 +102,8 @@ MACHINE_START(WG302V2, "Netgear WG302 v2
 	.timer		= &ixp4xx_timer,
 	.boot_params	= 0x0100,
 	.init_machine	= wg302v2_init,
+#if defined(CONFIG_PCI)
+	.dma_zone_size	= SZ_64M,
+#endif
 MACHINE_END
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-kirkwood/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-kirkwood/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-kirkwood/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-kirkwood/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -11,11 +11,4 @@
 
 #include "kirkwood.h"
 
-#define pcibios_assign_all_busses()	1
-
-#define PCIBIOS_MIN_IO			0x00001000
-#define PCIBIOS_MIN_MEM			0x01000000
-#define PCIMEM_BASE			KIRKWOOD_PCIE_MEM_PHYS_BASE /* mem base for VGA */
-
-
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-kirkwood/pcie.c torvalds-linux-v3.1-rc10/arch/arm/mach-kirkwood/pcie.c
--- linux-3.0/arch/arm/mach-kirkwood/pcie.c	2011-06-22 15:07:11.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-kirkwood/pcie.c	2011-10-18 04:06:23.000000000 +0000
@@ -12,6 +12,7 @@
 #include <linux/pci.h>
 #include <linux/slab.h>
 #include <linux/mbus.h>
+#include <video/vga.h>
 #include <asm/irq.h>
 #include <asm/mach/pci.h>
 #include <plat/pcie.h>
@@ -244,7 +245,8 @@ kirkwood_pcie_scan_bus(int nr, struct pc
 	return bus;
 }
 
-static int __init kirkwood_pcie_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int __init kirkwood_pcie_map_irq(const struct pci_dev *dev, u8 slot,
+	u8 pin)
 {
 	struct pcie_port *pp = bus_to_port(dev->bus);
 
@@ -271,6 +273,8 @@ static void __init add_pcie_port(int ind
 
 void __init kirkwood_pcie_init(unsigned int portmask)
 {
+	vga_base = KIRKWOOD_PCIE_MEM_PHYS_BASE;
+
 	if (portmask & KW_PCIE0)
 		add_pcie_port(0, PCIE_VIRT_BASE);
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ks8695/board-dsm320.c torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/board-dsm320.c
--- linux-3.0/arch/arm/mach-ks8695/board-dsm320.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/board-dsm320.c	2011-10-18 04:06:23.000000000 +0000
@@ -34,7 +34,7 @@
 #include "generic.h"
 
 #ifdef CONFIG_PCI
-static int dsm320_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int dsm320_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	switch (slot) {
 	case 0:
diff -NurpP --minimal linux-3.0/arch/arm/mach-ks8695/board-micrel.c torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/board-micrel.c
--- linux-3.0/arch/arm/mach-ks8695/board-micrel.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/board-micrel.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,7 +24,7 @@
 #include "generic.h"
 
 #ifdef CONFIG_PCI
-static int micrel_pci_map_irq(struct pci_dev *dev, u8 slot, u8 pin)
+static int micrel_pci_map_irq(const struct pci_dev *dev, u8 slot, u8 pin)
 {
 	return KS8695_IRQ_EXTERN0;
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-ks8695/include/mach/devices.h torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/include/mach/devices.h
--- linux-3.0/arch/arm/mach-ks8695/include/mach/devices.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/include/mach/devices.h	2011-10-18 04:06:23.000000000 +0000
@@ -30,7 +30,7 @@ extern void __init ks8695_init_leds(u8 c
 
 struct ks8695_pci_cfg {
 	short mode;
-	int (*map_irq)(struct pci_dev *, u8, u8);
+	int (*map_irq)(const struct pci_dev *, u8, u8);
 };
 extern __init void ks8695_init_pci(struct ks8695_pci_cfg *);
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-ks8695/include/mach/hardware.h torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/include/mach/hardware.h
--- linux-3.0/arch/arm/mach-ks8695/include/mach/hardware.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/include/mach/hardware.h	2011-10-18 04:06:23.000000000 +0000
@@ -42,13 +42,4 @@
 #define KS8695_PCIIO_PA		0x80000000
 #define KS8695_PCIIO_SIZE	SZ_64K
 
-
-/*
- * PCI support
- */
-#define pcibios_assign_all_busses()	1
-
-#define PCIBIOS_MIN_IO		0
-#define PCIBIOS_MIN_MEM		0
-
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-ks8695/pci.c torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/pci.c
--- linux-3.0/arch/arm/mach-ks8695/pci.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-ks8695/pci.c	2011-10-18 04:06:23.000000000 +0000
@@ -317,6 +317,9 @@ void __init ks8695_init_pci(struct ks869
 		return;
 	}
 
+	pcibios_min_io = 0;
+	pcibios_min_mem = 0;
+
 	printk(KERN_INFO "PCI: Initialising\n");
 	ks8695_show_pciregs();
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-lpc32xx/clock.c torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/clock.c
--- linux-3.0/arch/arm/mach-lpc32xx/clock.c	2011-04-03 18:49:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/clock.c	2011-10-18 04:06:23.000000000 +0000
@@ -1077,7 +1077,7 @@ static struct clk_lookup lookups[] = {
 	_REGISTER_CLOCK("lpc32xx-nand.0", "nand_ck", clk_nand)
 	_REGISTER_CLOCK("tbd", "i2s0_ck", clk_i2s0)
 	_REGISTER_CLOCK("tbd", "i2s1_ck", clk_i2s1)
-	_REGISTER_CLOCK("lpc32xx-ts", NULL, clk_tsc)
+	_REGISTER_CLOCK("ts-lpc32xx", NULL, clk_tsc)
 	_REGISTER_CLOCK("dev:mmc0", "MCLK", clk_mmc)
 	_REGISTER_CLOCK("lpc-net.0", NULL, clk_net)
 	_REGISTER_CLOCK("dev:clcd", NULL, clk_lcd)
diff -NurpP --minimal linux-3.0/arch/arm/mach-lpc32xx/common.c torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/common.c
--- linux-3.0/arch/arm/mach-lpc32xx/common.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/common.c	2011-10-18 04:06:23.000000000 +0000
@@ -95,6 +95,48 @@ struct platform_device lpc32xx_i2c2_devi
 	},
 };
 
+/* TSC (Touch Screen Controller) */
+
+static struct resource lpc32xx_tsc_resources[] = {
+	{
+		.start = LPC32XX_ADC_BASE,
+		.end = LPC32XX_ADC_BASE + SZ_4K - 1,
+		.flags = IORESOURCE_MEM,
+	}, {
+		.start = IRQ_LPC32XX_TS_IRQ,
+		.end = IRQ_LPC32XX_TS_IRQ,
+		.flags = IORESOURCE_IRQ,
+	},
+};
+
+struct platform_device lpc32xx_tsc_device = {
+	.name =  "ts-lpc32xx",
+	.id = -1,
+	.num_resources = ARRAY_SIZE(lpc32xx_tsc_resources),
+	.resource = lpc32xx_tsc_resources,
+};
+
+/* RTC */
+
+static struct resource lpc32xx_rtc_resources[] = {
+	{
+		.start = LPC32XX_RTC_BASE,
+		.end = LPC32XX_RTC_BASE + SZ_4K - 1,
+		.flags = IORESOURCE_MEM,
+	},{
+		.start = IRQ_LPC32XX_RTC,
+		.end = IRQ_LPC32XX_RTC,
+		.flags = IORESOURCE_IRQ,
+	},
+};
+
+struct platform_device lpc32xx_rtc_device = {
+	.name =  "rtc-lpc32xx",
+	.id = -1,
+	.num_resources = ARRAY_SIZE(lpc32xx_rtc_resources),
+	.resource = lpc32xx_rtc_resources,
+};
+
 /*
  * Returns the unique ID for the device
  */
diff -NurpP --minimal linux-3.0/arch/arm/mach-lpc32xx/common.h torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/common.h
--- linux-3.0/arch/arm/mach-lpc32xx/common.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/common.h	2011-10-18 04:06:23.000000000 +0000
@@ -28,6 +28,8 @@ extern struct platform_device lpc32xx_wa
 extern struct platform_device lpc32xx_i2c0_device;
 extern struct platform_device lpc32xx_i2c1_device;
 extern struct platform_device lpc32xx_i2c2_device;
+extern struct platform_device lpc32xx_tsc_device;
+extern struct platform_device lpc32xx_rtc_device;
 
 /*
  * Other arch specific structures and functions
diff -NurpP --minimal linux-3.0/arch/arm/mach-lpc32xx/include/mach/entry-macro.S torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/include/mach/entry-macro.S
--- linux-3.0/arch/arm/mach-lpc32xx/include/mach/entry-macro.S	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/include/mach/entry-macro.S	2011-10-18 04:06:23.000000000 +0000
@@ -41,7 +41,3 @@
 	rsb	\irqnr, \irqnr, #31
 	teq	\irqstat, #0
 	.endm
-
-	.macro	irq_prio_table
-	.endm
-
diff -NurpP --minimal linux-3.0/arch/arm/mach-lpc32xx/include/mach/vmalloc.h torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/include/mach/vmalloc.h
--- linux-3.0/arch/arm/mach-lpc32xx/include/mach/vmalloc.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-lpc32xx/include/mach/vmalloc.h	2011-10-18 04:06:23.000000000 +0000
@@ -19,6 +19,6 @@
 #ifndef __ASM_ARCH_VMALLOC_H
 #define __ASM_ARCH_VMALLOC_H
 
-#define VMALLOC_END	0xF0000000
+#define VMALLOC_END	0xF0000000UL
 
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-mmp/Kconfig torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/Kconfig
--- linux-3.0/arch/arm/mach-mmp/Kconfig	2011-04-03 18:49:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -77,6 +77,13 @@ config MACH_TETON_BGA
 	  Say 'Y' here if you want to support the Marvell PXA168-based
 	  Teton BGA Development Board.
 
+config MACH_SHEEVAD
+	bool "Marvell's PXA168 GuruPlug Display (gplugD) Board"
+	select CPU_PXA168
+	help
+	  Say 'Y' here if you want to support the Marvell PXA168-based
+	  GuruPlug Display (gplugD) Board
+
 endmenu
 
 config CPU_PXA168
diff -NurpP --minimal linux-3.0/arch/arm/mach-mmp/Makefile torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/Makefile
--- linux-3.0/arch/arm/mach-mmp/Makefile	2011-04-03 18:49:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/Makefile	2011-10-18 04:06:23.000000000 +0000
@@ -19,3 +19,4 @@ obj-$(CONFIG_MACH_BROWNSTONE)	+= brownst
 obj-$(CONFIG_MACH_FLINT)	+= flint.o
 obj-$(CONFIG_MACH_MARVELL_JASPER) += jasper.o
 obj-$(CONFIG_MACH_TETON_BGA)	+= teton_bga.o
+obj-$(CONFIG_MACH_SHEEVAD)	+= gplugd.o
diff -NurpP --minimal linux-3.0/arch/arm/mach-mmp/brownstone.c torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/brownstone.c
--- linux-3.0/arch/arm/mach-mmp/brownstone.c	2011-04-03 18:49:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/brownstone.c	2011-10-18 04:06:23.000000000 +0000
@@ -177,9 +177,16 @@ static struct i2c_board_info brownstone_
 };
 
 static struct sdhci_pxa_platdata mmp2_sdh_platdata_mmc0 = {
-	.max_speed	= 25000000,
+	.clk_delay_cycles = 0x1f,
+};
+
+static struct sdhci_pxa_platdata mmp2_sdh_platdata_mmc2 = {
+	.clk_delay_cycles = 0x1f,
+	.flags = PXA_FLAG_CARD_PERMANENT
+		| PXA_FLAG_SD_8_BIT_CAPABLE_SLOT,
 };
 
+
 static void __init brownstone_init(void)
 {
 	mfp_config(ARRAY_AND_SIZE(brownstone_pin_config));
@@ -189,6 +196,7 @@ static void __init brownstone_init(void)
 	mmp2_add_uart(3);
 	mmp2_add_twsi(1, NULL, ARRAY_AND_SIZE(brownstone_twsi1_info));
 	mmp2_add_sdhost(0, &mmp2_sdh_platdata_mmc0); /* SD/MMC */
+	mmp2_add_sdhost(2, &mmp2_sdh_platdata_mmc2); /* eMMC */
 
 	/* enable 5v regulator */
 	platform_device_register(&brownstone_v_5vp_device);
diff -NurpP --minimal linux-3.0/arch/arm/mach-mmp/clock.c torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/clock.c
--- linux-3.0/arch/arm/mach-mmp/clock.c	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/clock.c	2011-10-18 04:06:23.000000000 +0000
@@ -88,3 +88,18 @@ unsigned long clk_get_rate(struct clk *c
 	return rate;
 }
 EXPORT_SYMBOL(clk_get_rate);
+
+int clk_set_rate(struct clk *clk, unsigned long rate)
+{
+	unsigned long flags;
+	int ret = -EINVAL;
+
+	if (clk->ops->setrate) {
+		spin_lock_irqsave(&clocks_lock, flags);
+		ret = clk->ops->setrate(clk, rate);
+		spin_unlock_irqrestore(&clocks_lock, flags);
+	}
+
+	return ret;
+}
+EXPORT_SYMBOL(clk_set_rate);
diff -NurpP --minimal linux-3.0/arch/arm/mach-mmp/clock.h torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/clock.h
--- linux-3.0/arch/arm/mach-mmp/clock.h	2011-04-03 18:49:56.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/clock.h	2011-10-18 04:06:23.000000000 +0000
@@ -12,6 +12,7 @@ struct clkops {
 	void			(*enable)(struct clk *);
 	void			(*disable)(struct clk *);
 	unsigned long		(*getrate)(struct clk *);
+	int			(*setrate)(struct clk *, unsigned long);
 };
 
 struct clk {
diff -NurpP --minimal linux-3.0/arch/arm/mach-mmp/gplugd.c torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/gplugd.c
--- linux-3.0/arch/arm/mach-mmp/gplugd.c	1970-01-01 00:00:00.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-mmp/gplugd.c	2011-10-18 04:06:23.000000000 +0000
@@ -0,0 +1,197 @@
+/*
+ *  linux/arch/arm/mach-mmp/gplugd.c
+ *
+ *  Support for the Marvell PXA168-based GuruPlug Display (gplugD) Platform.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  publishhed by the Free Software Foundation.
+ */
+
+#include <linux/init.h>
+
+#include <asm/mach/arch.h>
+#include <asm/mach-types.h>
+
+#include <mach/gpio.h>
+#include <mach/pxa168.h>
+#include <mach/mfp-pxa168.h>
+
+#include "common.h"
+
+static unsigned long gplugd_pin_config[] __initdata = {
+	/* UART3 */
+	GPIO8_UART3_TXD,
+	GPIO9_UART3_RXD,
+	GPIO1O_UART3_CTS,
+	GPIO11_UART3_RTS,
+
+	/* USB OTG PEN */
+	GPIO18_GPIO,
+
+	/* MMC2 */
+	GPIO28_MMC2_CMD,
+	GPIO29_MMC2_CLK,
+	GPIO30_MMC2_DAT0,
+	GPIO31_MMC2_DAT1,
+	GPIO32_MMC2_DAT2,
+	GPIO33_MMC2_DAT3,
+
+	/* LCD & HDMI clock selection GPIO: 0: 74.176MHz, 1: 74.25 MHz */
+	GPIO35_GPIO,
+	GPIO36_GPIO, /* CEC Interrupt */
+
+	/* MMC1 */
+	GPIO43_MMC1_CLK,
+	GPIO49_MMC1_CMD,
+	GPIO41_MMC1_DAT0,
+	GPIO40_MMC1_DAT1,
+	GPIO52_MMC1_DAT2,
+	GPIO51_MMC1_DAT3,
+	GPIO53_MMC1_CD,
+
+	/* LCD */
+	GPIO56_LCD_FCLK_RD,
+	GPIO57_LCD_LCLK_A0,
+	GPIO58_LCD_PCLK_WR,
+	GPIO59_LCD_DENA_BIAS,
+	GPIO60_LCD_DD0,
+	GPIO61_LCD_DD1,
+	GPIO62_LCD_DD2,
+	GPIO63_LCD_DD3,
+	GPIO64_LCD_DD4,
+	GPIO65_LCD_DD5,
+	GPIO66_LCD_DD6,
+	GPIO67_LCD_DD7,
+	GPIO68_LCD_DD8,
+	GPIO69_LCD_DD9,
+	GPIO70_LCD_DD10,
+	GPIO71_LCD_DD11,
+	GPIO72_LCD_DD12,
+	GPIO73_LCD_DD13,
+	GPIO74_LCD_DD14,
+	GPIO75_LCD_DD15,
+	GPIO76_LCD_DD16,
+	GPIO77_LCD_DD17,
+	GPIO78_LCD_DD18,
+	GPIO79_LCD_DD19,
+	GPIO80_LCD_DD20,
+	GPIO81_LCD_DD21,
+	GPIO82_LCD_DD22,
+	GPIO83_LCD_DD23,
+
+	/* GPIO */
+	GPIO84_GPIO,
+	GPIO85_GPIO,
+
+	/* Fast-Ethernet*/
+	GPIO86_TX_CLK,
+	GPIO87_TX_EN,
+	GPIO88_TX_DQ3,
+	GPIO89_TX_DQ2,
+	GPIO90_TX_DQ1,
+	GPIO91_TX_DQ0,
+	GPIO92_MII_CRS,
+	GPIO93_MII_COL,
+	GPIO94_RX_CLK,
+	GPIO95_RX_ER,
+	GPIO96_RX_DQ3,
+	GPIO97_RX_DQ2,
+	GPIO98_RX_DQ1,
+	GPIO99_RX_DQ0,
+	GPIO100_MII_MDC,
+	GPIO101_MII_MDIO,
+	GPIO103_RX_DV,
+	GPIO104_GPIO,     /* Reset PHY */
+
+	/* RTC interrupt */
+	GPIO102_GPIO,
+
+	/* I2C */
+	GPIO105_CI2C_SDA,
+	GPIO106_CI2C_SCL,
+
+	/* SPI NOR Flash on SSP2 */
+	GPIO107_SSP2_RXD,
+	GPIO108_SSP2_TXD,
+	GPIO110_GPIO,     /* SPI_CSn */
+	GPIO111_SSP2_CLK,
+
+	/* Select JTAG */
+	GPIO109_GPIO,
+
+	/* I2S */
+	GPIO114_I2S_FRM,
+	GPIO115_I2S_BCLK,
+	GPIO116_I2S_TXD
+};
+
+static struct i2c_board_info gplugd_i2c_board_info[] = {
+	{
+		.type = "isl1208",
+		.addr = 0x6F,
+	}
+};
+
+/* Bring PHY out of reset by setting GPIO 104 */
+static int gplugd_eth_init(void)
+{
+	if (unlikely(gpio_request(104, "ETH_RESET_N"))) {
+		printk(KERN_ERR "Can't get hold of GPIO 104 to bring Ethernet "
+				"PHY out of reset\n");
+		return -EIO;
+	}
+
+	gpio_direction_output(104, 1);
+	gpio_free(104);
+	return 0;
+}
+
+struct pxa168_eth_platform_data gplugd_eth_platform_data = {
+	.port_number = 0,
+	.phy_addr    = 0,
+	.speed       = 0, /* Autonagotiation */
+	.init        = gplugd_eth_init,
+};
+
+static void __init select_disp_freq(void)
+{
+	/* set GPIO 35 & clear GPIO 85 to set LCD External Clock to 74.25 MHz */
+	if (unlikely(gpio_request(35, "DISP_FREQ_SEL"))) {
+		printk(KERN_ERR "Can't get hold of GPIO 35 to select display "
+				"frequency\n");
+	} else {
+		gpio_direction_output(35, 1);
+		gpio_free(35);
+	}
+
+	if (unlikely(gpio_request(85, "DISP_FREQ_SEL_2"))) {
+		printk(KERN_ERR "Can't get hold of GPIO 85 to select display "
+				"frequency\n");
+	} else {
+		gpio_direction_output(85, 0);
+		gpio_free(85);
+	}
+}
+
+static void __init gplugd_init(void)
+{
+	mfp_config(ARRAY_AND_SIZE(gplugd_pin_config));
+
+	select_disp_freq();
+
+	/* on-chip devices */
+	pxa168_add_uart(3);
+	pxa168_add_ssp(0);
+	pxa168_add_twsi(0, NULL, ARRAY_AND_SIZE(gplugd_i2c_board_info));
+
+	pxa168_add_eth(&gplugd_eth_platform_data);
+}
+
+MACHINE_START(SHEEVAD, "PXA168-based GuruPlug Display (gplugD) Platform")
+	.map_io		= mmp_map_io,
+	.nr_irqs	= IRQ_BOARD_START,
+	.init_irq       = pxa168_init_irq,
+	.timer          = &pxa168_timer,
+	.init_machine   = gplugd_init,
+MACHINE_END
